/**********************************************

Author Cao Yang
Date: 2013.3.29
g++  AddH.cpp -o AddH

**********************************************/
#include <sstream> 
#include <fstream>
#include <iomanip>
#include <iostream>
#include <string>
#include <vector>
#include <ctime>
#include <cmath>
#include <cstdlib>
#include "../basic.hpp"
#include "../Rotamer2Structure.hpp"

using namespace std;


int main(int argc, char **argv)
{
      if(argc<3)
      {
	    cout<<"Error input!\n";
	    cout<<"Usage: AddH  [pdb file] [output pdb file]\n";
          return 0;
      }

	EXEDIR("../dat/");
	

      vector<ResUnit> mol_tag;
      vector<int> tag_index;
      
      ReadRes(res_atom.c_str());   
      ReadPDB(argv[1], mol_tag, tag_index);
      cout<<"Adding Hydrogen ...\n";
      
      Rotamer2Structure r2s(top_para.c_str());
      
      for(int i=0; i<tag_index.size(); i++)
      {
                  r2s.ConstructHN(i, mol_tag, tag_index);
                  r2s.ConstructHs(i, mol_tag, tag_index);
      }
      OutputStdPDB(mol_tag, tag_index, argv[2]);
      

      return 1;
}
