#!/usr/bin/env python
"""
./4_integrated_features.py ./2_probability/ ./4_top70/all 0 0 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 61 62 63 64 65 66 67 68 69 70 71
"""
import sys
import numpy

def readFile(infile):
	fin = open(infile,"r")
	line = fin.readline()
	data = []
	while line:
		cells = line.strip().split()
		data.append(cells)
		line = fin.readline()
	fin.close()
	return numpy.array(data).reshape((len(data),len(data[0])))

def nRows(infile):
	fin = open(infile,"r")
	content = fin.read()
	line = content.strip().split("\n")
	print len(line)
	return len(line)

def classFile(classname,columns):
	num = nRows(classname+"diseasedp0")
	df = numpy.zeros((num,1))
	dp = numpy.zeros((num,1))
	
	diffp = numpy.zeros((num,1))

	nf = numpy.zeros((num,1))
	np = numpy.zeros((num,1))

	#dl = readFile(classname+"diseasel"+str(columns[0]))
	#nl = readFile(classname+"neutrall"+str(columns[0]))

	for i in range(len(columns)):
		dtempf = readFile(classname+"diseasef"+str(columns[i]))
		dtempp = readFile(classname+"diseasep"+str(columns[i]))

		tempdp = readFile(classname+"diseasedp"+str(columns[i]))
		
		ntempf = readFile(classname+"neutralf"+str(columns[i]))
		ntempp = readFile(classname+"neutralp"+str(columns[i]))

		df = numpy.hstack((df,dtempf))
		dp = numpy.hstack((dp,dtempp))

		diffp = numpy.hstack((diffp,tempdp))

		nf = numpy.hstack((nf,ntempf))
		np = numpy.hstack((np,ntempp))

	df = numpy.delete(df,0,1)
	dp = numpy.delete(dp,0,1)
	
	diffp = numpy.delete(diffp,0,1)
	
	nf = numpy.delete(nf,0,1)
	np = numpy.delete(np,0,1)

	#return df,dp,dl,diffp,nf,np,nl
	return df,dp,diffp,nf,np

def writeFile(filename,data):
	fin = open(filename,"w")
	for i in range(data.shape[0]):
		line = ""
		for j in range(data.shape[1]):
			line += data[i,j]+" "
		line += "\n"
		fin.write(line)
	fin.close()

def writeLogFile(filename,data):
	fin = open(filename,"w")
	data = logdata(data)
	for i in range(data.shape[0]):
		line = ""
		for j in range(data.shape[1]):
			line += str(data[i,j])+" "
		line += "\n"
		fin.write(line)
	fin.close()

def writeNormFile(filename,data):
	fin = open(filename,"w")
	data = normalization(data)
	for i in range(data.shape[0]):
		line = ""
		for j in range(data.shape[1]):
			line += data[i,j]+" "
		line += "\n"
		fin.write(line)
	fin.close()

#def writeClass(filename,df,dp,dl,diffp,nf,np,nl,norm,log):
def writeClass(filename,df,dp,diffp,nf,np,norm,log):
	if norm == 0:
		writeFile(filename+"diseasef",df)
	elif norm == 1:
		writeNormFile(filename+"diseasef",df)
	if log == 0:
		writeFile(filename+"diseasep",dp)
	elif log == 1:
		writeLogFile(filename+"diseasep",dp)
	#writeFile(filename+"diseasel",dl)
	
	writeFile(filename+"diseasedp",diffp)
	
	if norm == 0:
		writeFile(filename+"neutralf",nf)
	elif norm == 1:
		writeNormFile(filename+"neutralf",nf)
	if log == 0:
		writeFile(filename+"neutralp",np)
	elif log == 1:
		writeLogFile(filename+"neutralp",np)
	#writeFile(filename+"neutrall",nl)

def logdata(data):
	return numpy.log2(data.astype(numpy.float)+1)

def normalization(data):
	for i in range(data.shape[1]):
		temp = data[:,i]
		temp = temp[temp!="#"]
		tempdata = []
		for k in temp:
			tempdata.append(float(k))
		maxd = max(tempdata)
		mind = min(tempdata)
		for j in range(data.shape[0]):
			if data[j,i] != "#":
				#data[j,i] = 2*(float(data[j,i])-mind)/(maxd-mind)-1
				data[j,i] = 0.1+(float(data[j,i])-mind)/(maxd-mind)*(0.9-0.1)# nomalize to 0.1~0.9
	print data.dtype.name
	return data


if __name__ == "__main__":
	classname = sys.argv[1]
	outname = sys.argv[2]
	norm = 0 # norm = 1 means inputs are nomalized
	norm  = int(sys.argv[3])
	log = 0 #log = 1 means inputs are log
	log = int(sys.argv[4])
	columns = []
	for i in range(5,len(sys.argv)):
		columns.append(sys.argv[i])
	#df,dp,dl,diffp,nf,np,nl = classFile(classname,columns)
	df,dp,diffp,nf,np = classFile(classname,columns)
	#writeClass(outname,df,dp,dl,diffp,nf,np,nl,norm,log)
	writeClass(outname,df,dp,diffp,nf,np,norm,log)
