#!/usr/bin/env python
"""
./integrateFeautre4user.py /nfs/amino-home/zhanglabs/PreDAM/output/DAM100017/tmp/features /nfs/amino-home/zhanglabs/PreDAM/output/DAM100017/tmp/featuresPvalueTop20 L_20_A-K_105_M 6 7 8 9 11 16 28 33 36 41 42 44 45 46 51 52 57 62 64 66
"""
import sys
import numpy

def readFile(infile, columns):
	fin = open(infile,"r")
	line = fin.readline()
	data = []
	while line:
		cells = line.strip().split()
		data.append(cells)
		line = fin.readline()
	fin.close()
	data = numpy.array(data).reshape((len(data),len(data[0])))
        newData = data[:,columns[0]].reshape((data.shape[0],1))
        for i in range(1,len(columns)):
            newData = numpy.concatenate((newData,data[:,columns[i]].reshape((data.shape[0],1))),axis=1)
        return newData

def writeFile(filename,mutations,data):
	fin = open(filename,"w")
        fin.write("Position wild mutant PSICw PSICm dPSIC tPSICw dtPSIC noCw noCm noARm coswm rmsNwm rmsNSwm Pfamw Pfamm dPfam JSDi Depth dVDW CISRRm Intra CIntra\n")
	for i in range(data.shape[0]):
                cells = mutations[i].strip().split('_')
                aa1 = cells[0]
                pos = cells[1]
                aa2 = cells[2]
		line = pos+" "+aa1+" "+aa2+" "
		for j in range(data.shape[1]):
                    if data[i,j] == "#":
		        line += data[i,j] +" "
                    else:
		        line += str(float('%.3f' % float(data[i,j])))+" "
		line += "\n"
		fin.write(line)
	fin.close()


if __name__ == "__main__":
	classname = sys.argv[1]
	outname = sys.argv[2]
	mutations = sys.argv[3].strip().split('-')
	columns = []
	for i in range(4,len(sys.argv)):
		columns.append(int(sys.argv[i]))
        
        data = readFile(classname,columns)
        writeFile(outname,mutations,data)
