#!/usr/bin/env python

"""
./1_normalize_features.py ../features/tp53features ./MinMax.txt ./tp53featuresNew
"""
import sys
import numpy as np

def _normalizeNumeric(column,mindata,maxdata):
	newdata = []
	for i in column:
		if i == '#':
			newdata.append('#')
		else:
			if float(i) > maxdata:
				i = maxdata
			if float(i) < mindata:
				i = mindata
			newdata.append(round(0.1+(float(i)-mindata)/(maxdata-mindata)*(1-0.1),6))
	newdata = np.array(newdata)
	return newdata.reshape(newdata.shape[0],1)

def _normalization(column,mindata,maxdata):
	newdata = []
	#if len(tempdata) != len(column):	
	#tempbin = (maxdata-mindata)/len(tempdata)
	for i in column:
		if i == '#':
			print "Errror: this feature does not have #"
		else:
			if float(i) > maxdata:
				i = maxdata
			if float(i) < mindata:
				i = mindata
			newdata.append(round((float(i)-mindata)/(maxdata-mindata),6))
	newdata = np.array(newdata)
	return newdata.reshape(newdata.shape[0],1)

def _normalizeInteger(column,mindata,maxdata):
	newdata = []
	mindata = mindata-1
	for i in column:
		if i == '#':
			newdata.append('#')
		else:
			if float(i) > maxdata:
				i = maxdata
			if float(i) < mindata:
				i = mindata
			newdata.append(round((float(i)-mindata)/(maxdata-mindata),6))
	newdata = np.array(newdata)
	return newdata.reshape(newdata.shape[0],1)


def _getAllData(infile):
	inf = open(infile,'r')
	lines = inf.readline()	
	datas = []
	while lines:
		#if lines[0]=='@' or lines.strip()=='':
		if lines.strip()=='':
			lines = inf.readline()
			continue
		datas.append(lines.strip().split(' '))
		lines = inf.readline()
	inf.close()
	return np.array(datas)


def _extractFeatures(data,minData,maxData):
	
	allfeatures = _normalization(data[:,0],minData[0],maxData[0])
	#for i in range(1,ddata.shape[1]):
	for i in range(1,6):
		dtemp = _normalization(data[:,i],minData[i],maxData[i])
		allfeatures = np.hstack((allfeatures,dtemp))

	for i in range(6,12):
		dtemp = _normalizeNumeric(data[:,i],minData[i],maxData[i])
		allfeatures = np.hstack((allfeatures,dtemp))

	for i in range(12,36):
		dtemp = _normalizeInteger(data[:,i],minData[i],maxData[i])
		allfeatures = np.hstack((allfeatures,dtemp))

	for i in range(36,64):
		dtemp = _normalizeNumeric(data[:,i],minData[i],maxData[i])
		allfeatures = np.hstack((allfeatures,dtemp))

	for i in range(64,72):
		dtemp = _normalizeInteger(data[:,i],minData[i],maxData[i])
		allfeatures = np.hstack((allfeatures,dtemp))

	print allfeatures.shape
	return allfeatures

def _minMax(infile):
	lines = open(infile,'r')
	minData = []
	maxData = []
	for line in lines:
		cells = line.strip().split('\t')
		minData.append(float(cells[0]))
		maxData.append(float(cells[1]))
	return minData,maxData

def _printFeatures(allfeatures,outfile):
	outf = open(outfile,'w')
	for i in range(0,allfeatures.shape[0]):
		for j in range(0,allfeatures.shape[1]):
			outf.write(str(allfeatures[i,j])+" ")
		outf.write("\n") 
	outf.close()

if __name__=='__main__':
	featuresfile = sys.argv[1]
	MinMaxFile = sys.argv[2]
	outfile = sys.argv[3]
	minData,maxData = _minMax(MinMaxFile)
	data = _getAllData(featuresfile)

	allfeatures = _extractFeatures(data,minData,maxData)
	_printFeatures(allfeatures,outfile)
