#!/usr/bin/env python
"""
./8_voting.py ./4_top70/alldiseasep_results ./4_top70/allneutralp_results ./4_top70/alldiseasedp_results ./final.results
"""
import sys,math
import numpy as np

def readresults(infile):
	inf = open(infile,'r')
	line = inf.readline()
	predict = []
	real = []
	while line:
		cells = line.strip().split()
		predict.append(float(cells[0]))
		line = inf.readline()
	inf.close()
	return np.array(predict)

def voting(Dmethod1,Nmethod2,Diffmethod3):
	targetD= []
	targetN= []
	targetDiff = []
	for i in range(Dmethod1.shape[0]):
		if Dmethod1[i] >= 0.5:
			targetD.append(1.0)
		else:
			targetD.append(0.0)
			
		if Nmethod2[i]<= 0.5:
			targetN.append(1.0)
		else:
			targetN.append(0.0)

		if Diffmethod3[i] >= 0.5:
			targetDiff.append(1.0)
		else:
			targetDiff.append(0.0)
	predictions = np.array(targetD)+np.array(targetN)+np.array(targetDiff)
	return predictions


if __name__=="__main__":
	diseasef = sys.argv[1]
	neutralf = sys.argv[2]
	dpf = sys.argv[3]
	outfile = sys.argv[4]
        mutations = sys.argv[5]
        mutations = mutations.strip().split('-')
	ddata = readresults(diseasef)
	ndata = readresults(neutralf)
	dpdata = readresults(dpf)
	predictions = voting(ddata,ndata,dpdata)

	fout = open(outfile,'w')		
	for i in range (ddata.shape[0]):
                cells = mutations[i].strip().split('_')
                aa1 = cells[0]
                pos = cells[1]
                aa2 = cells[2]
		outline = pos+"\t"+aa1+"\t"+aa2+"\t"+str(float('%.3f' % ddata[i]))+"\t"+str(float('%.3f' % ndata[i]))+"\t"+str(float('%.3f' % dpdata[i]))+"\t"+str(predictions[i])+"\n"
		fout.write(outline)
	fout.close()
