/*----------------------------------------------------------------------------*/
/*                                                                            */
/*                             CharSeqLongSet.h                               */
/*                                                                            */
/* A class for a very large set of character sequences, all having the same   */
/* length and terminating with a '\0'. The number of sequences in the set can */
/* be as large as allowed by type long.                                       */
/*                                                                            */
/*----------------------------------------------------------------------------*/

#ifndef CHAR_SEQ_LONG_SET_H
#define CHAR_SEQ_LONG_SET_H

#include <stdio.h>

namespace CharSeq {
  
  class CharSeqLongSet {

    long int numseq; // num. sequences in the set
    int seqlen; // num. characters in each sequence.
    char** set; // the set

    public:
    CharSeqLongSet(FILE* fp);
    ~CharSeqLongSet();
 
    long int getNumSeq() const {return numseq;}
    int getSeqLen() const {return seqlen;}

    void printSeq(FILE* fp, const long int idx) {fprintf(fp, "%s", set[idx]);}
    void printSet(FILE* fp);

    inline char get(long int seq, int cha) const {return set[seq][cha];}
  };
}

#endif
