#!/usr/bin/env python

import re,os,urllib,sys,sqlite3
from subprocess import Popen,PIPE
import userConfig


def rmfile(myfile):
	if os.path.isfile(myfile):
		os.remove(myfile)

def download(url,local):
	urllib.urlretrieve(url,local)

def checkSlash(route):
	if route.strip()[-1] != '/':
		route = route.strip()+"/"
	return route

#-------------------------------------------------------------------------------------
#-------------------------------------------------------------------------------------

outfile =sys.argv[1]
outfile = checkSlash(outfile)
if not os.path.exists(outfile):
	print "the "+outfile+" does not exitst!"
	sys.exit()

pfam_ftp = 'ftp://ftp.ebi.ac.uk/pub/databases/Pfam/current_release/Pfam-A.hmm.gz'
print "Downloading "+pfam_ftp+" ..."
local = pfam_ftp.split('/')[-1]
rmfile(outfile+local)
download(pfam_ftp,outfile+local)

print "Decompressing "+local	
cmd = 'gunzip -f '+outfile+local
s = Popen(cmd,shell = True, stdout=PIPE,stderr=PIPE)
stdout, stderr = s.communicate()
if stderr != '':
	print stderr
	sys.exit()
print "Done."

infile = open(outfile+'Pfam-A.hmm','r')
pfams = infile.read().strip().split('//')
for pfam in pfams:
	lines = pfam.strip().split('\n')	
	for line in lines:
		match = re.match('^ACC   (\w+)\.',line)
		if match:
			acc = match.group(1)
			print acc
			outf = open(outfile+acc+'.hmm','w')
			outf.write(pfam.strip()+'\n')
			outf.write('//\n')
			outf.close()
			break
infile.close()
rmfile(outfile+'Pfam-A.hmm')
