#!/usr/bin/env python
import re,sys,os
import preparation

ts = {'GLY':'G',
	'ALA':'A',
	'VAL':'V',
	'LEU':'L',
	'ILE':'I',
	'SER':'S',
	'THR':'T',
	'CYS':'C',
	'MET':'M',
	'PRO':'P',
	'ASP':'D',
	'ASN':'N',
	'GLU':'E',
	'GLN':'Q',
	'LYS':'K',
	'ARG':'R',
	'HIS':'H',
	'PHE':'F',
	'TYR':'Y',
	'TRP':'W',

	'ASX':'B',
	'GLX':'Z',
	'UNK':'X'}


def get_mta(initFile,seq,outFile):
	outFile = preparation.check_slash(outFile)
	if not os.path.isfile(initFile): 
		print 'ERROR: '+initFile+' does not exist!'
		sys.exit()
	fin = open(initFile,'r')
	line = fin.readline()
	match = re.search('^\s*(\S+)\s+(\S+)\s+(\S+)',line)
	if match:
		nTemp = int(match.group(1))	
		nType = match.group(2)
		nGood = match.group(3)
	else:
		print 'ERROR: the format ('+initFile+') is not right.'
		sys.exit()

	psicInFile = outFile+'templatePsicIn'
	fout = open(psicInFile,'w')
	fout.write('CLUSTAL\n\n')
	fout.write('_'*(67-len('name0'))+'name0 '+seq+'\n')
	for j in range(0,nTemp):
		##read Ca from template
		line = fin.readline()
		head = line
		lAli = 0
		nQuery = 0
		
		match = re.search('(\S+)\s+\S+\s+\S+\s+(\S+)\s+(\S+)',line)
		if match:
			lAli = int(match.group(1))	
			tempName = match.group(2)
			tempName = re.sub('\@','',tempName)
			ori = match.group(3)
			nQuery = len(seq)
			outAliSeq = []
			qRes = {}
			query = {}
			aliRes = {}
			aliSeq = {}
			
		else:
			match = re.search('(\S+)\s+\S+\s+\S+\s+(\S+)',line)
			if match:
				lAli = int(match.group(1))	
				tempName = match.group(2)
				tempName = re.sub('\@','',tmpName)
				ori = 'unknown'
				nQuery = len(seq)
				outAliSeq = []

		for i in range(0,lAli):
			line = fin.readline()
			qRes[i] = int(re.sub('\s','',line[22:26]))	
			query[qRes[i]] = line[17:20]
			match = re.search('(\d+)\s+(\S\S\S)',line[54:63])
			if match:
				aliRes[qRes[i]] = match.group(1)
				aliSeq[qRes[i]] = match.group(2)	
		
		for i in range(0,nQuery):
			if query.has_key(i+1):
				if aliSeq.has_key(i+1):
					if ts.has_key(aliSeq[i+1]):
						outAliSeq.append(ts[aliSeq[i+1]])		
					else:
						outAliSeq.append('-')		
				else:
					outAliSeq.append('-')		
			else:
				outAliSeq.append('-')		
			if i == (nQuery-1):
				if not (''.join(outAliSeq) =='-'*nQuery):
					newname = 'name'+str(j+1)
					fout.write('_'*(67-len(newname))+newname+' '+''.join(outAliSeq)+'\n')
		
		line = fin.readline()
			
	fin.close()
	fout.close()
	return psicInFile 
