#!/usr/bin/python
import sys,os,math
import userConfig, preparation,urllib

hmmAA = {
        'A':0,
        'C':1,
        'D':2,
        'E':3,
        'F':4,
        'G':5,
        'H':6,
        'I':7,
        'K':8,
        'L':9,
        'M':10,
        'N':11,
        'P':12,
        'Q':13,
        'R':14,
        'S':15,
        'T':16,
        'V':17,
        'W':18,
        'Y':19};


def run_pfam_scan(seqFile, outdir):
	outdir = preparation.check_slash(outdir)
	preparation.rmfile(outdir+'seq.pfam')
	#cmd = 'perl -I /nfs/amino-home/zhanglabs/PreDAM/bin/pfam/lib/perl5 -I  /nfs/amino-home/zhanglabs/PreDAM/bin/pfam/PfamScan '+userConfig.pfamScan+' -fasta '+seqFile+' -dir '+userConfig.libPfam+' -align -outfile '+outdir+'seq.pfam'
	cmd = userConfig.pfamScan+' -fasta '+seqFile+' -dir '+userConfig.libPfam+' -align -outfile '+outdir+'seq.pfam'
	print cmd
	preparation.run_cmd(cmd)	
	return outdir+'seq.pfam'


def read_pfam(pfamfile, pdbname, pos, wild, mutant,hmmdir):
        if not os.path.isfile(pfamfile):
                return False, False, False, False, False
        f = open(pfamfile,"r")
        content = f.read()
        lines = content.strip().split("\n")
        f.close()

        lable = 0
        hmmseq = ""
        seq = ""
        for i in range(0,len(lines)):
                if not lines[i]:
                        continue
                cells = lines[i].strip().split()
                if cells[0] == pdbname:
                        start = int(cells[1])
                        end = int(cells[2])
                        if pos >= start and pos <= end:
                                lable += 1
                                startT = start
                                endT = end

                                hmmacc = cells[5].split(".")[0]
                                #os.system("wget -O "+hmmdir+hmmacc+".hmm http://pfam.xfam.org/family/"+hmmacc+"/hmm")
                                #urllib.urlretrieve("http://pfam.xfam.org/family/"+hmmacc+"/hmm",hmmdir+hmmacc+".hmm")
                                dtype = cells[7]
                                hmmstart = int(cells[8])
                                hmmend = int(cells[9])
                                bitscore = cells[11]
                                clan = cells[14]

                                if lable == 2:
                                        hmmseq = ""
                                        seq = ""
                                        lable =1
                        continue
                if cells[0] == "#HMM" and lable ==1:
                        hmmseq += cells[1]
                if cells[0] == "#SEQ" and lable ==1:
                        seq += cells[1]

        if lable == 0:
                return -1,-1,-1,-1,-1

        Rindex = startT-1
        for i in range(0,len(seq)):
                if seq[i] == "-":
                        continue
                Rindex += 1
                if Rindex == pos:
                        HmmR = i
                        break

        Hmmindex = hmmstart-1
        for i in range(0,HmmR+1):
                if hmmseq[i] == ".":
                        continue
                Hmmindex += 1
        #f = open(hmmdir+"/"+hmmacc+".hmm","r")
        f = open(userConfig.hmmLib+"/"+hmmacc+".hmm","r")
        line = f.readline()
        wildscore = 0
        mutantscore = 0
        while line:
		cells = line.strip().split()
                if cells[0] == "HMM":
                        line = f.readline()
                        line = f.readline()
                        while line:
                                cells = line.strip().split()
                                if cells[0] == "COMPO":
                                        line = f.readline()
                                        line = f.readline()
                                elif cells[0] == '//':
                                        return -1,  -1, dtype, bitscore, clan
                                elif line[0:7] != "       ":
                                        node = int(cells[0])
                                        if node == Hmmindex:
                                                if hmmseq[HmmR] == ".":
                                                        line = f.readline()
                                                        #insert emission
                                                        emission = line.strip().split()
                                                        wildscore = emission[hmmAA[wild]]
                                                        mutantscore = emission[hmmAA[mutant]]
                                                        break
                                                else:
                                                        #match emission
                                                        emission = line.strip().split()
                                                        wildscore = emission[hmmAA[wild]+1]
                                                        mutantscore = emission[hmmAA[mutant]+1]
                                                        break
                                        else:
                                                line = f.readline()
                                                line = f.readline()
                                line = f.readline()
                line = f.readline()

        return float(wildscore), float(mutantscore), dtype, bitscore, clan


def get_pfam_value(pfamFile, name, pos, wild, mutant,outdir):
        outdir = preparation.check_slash(outdir)
        wildpfam, mutantpfam, dtype, bitscore, clan = read_pfam(pfamFile, name, int(pos), wild, mutant,outdir)
        features = []
        if wildpfam == False:
                #features.append("#")
                #features.append("#")
                features.append("#")
                features.append("#")
                features.append("#")
                #features.append("#")
                #features.append("#")
                #features.append("#")
                #features.append("#")
        #elif wildpfam == -1:
         #       features.append("0")
          #      features.append("0")
           #     features.append("0")
        else:
                #wildprobability = math.exp(-wildpfam)
                #mutantprobability = math.exp(-mutantpfam)
                features.append(wildpfam)
                features.append(mutantpfam)
                features.append(mutantpfam-wildpfam)
                #features.append(wildprobability)
                #features.append(mutantprobability)
                #features.append(mutantprobability-wildprobability)
                #features.append(dtype)
                #features.append(bitscore)
                #features.append(clan)
	return features

