#!/usr/bin/env python
import sys,re,os,sqlite3
import userConfig,preparation,alignment

BONDS = ['CROSSLNK','DISULFID']
CSITES = ['METAL','ACT_SITE','BINDING','LIPID']
REGIONS = ['TRANSMEM', 'INTRAMEM', 'COMPBIAS', 'REPEAT', 'COILED', 'SIGNAL', 'PROPEP']
SITES = ['SITE', 'DISULFID', 'CROSSLNK', 'MOD_RES', 'CARBOHYD', 'NON_STD']

def fetchone(conn, sql, data,lable):
	features = []
	if sql is not None and sql != '':
		if data is not None:
			cur = conn.cursor()
			#print 'sql: '+sql
			cur.execute(sql, data)
			r = cur.fetchall()
			if len(r) > 0:
				for e in range(len(r)):
					if lable == 0:
						features.append(str(r[e][0]))
						#print r[e][0]
					else:
						features.append(r[e])
		else:
			print 'the [{}] equal None!'.format(data)
	else:
		print 'the [{}] is empty or equal None!'.format(sql)

	return features

def search_residue_uniprot_features(acc,pos): 
	bonds = '"'+'","'.join(BONDS)+'"'
	csites = '"'+'","'.join(CSITES)+'"'
	#print bonds
	#print csites
	select = 'SELECT name, start, end FROM features WHERE acc = ? AND ?2 BETWEEN start AND end' 
	if len(acc) == 0:
		print 'ERROR: missing accession'
		#sys.exit()
		return []
	if pos == 0:
		print 'ERROR: missing pos'
		#sys.exit()
		return []

	dbfile = userConfig.humanDB+'.sqlite' 
	if (not os.path.exists(dbfile)) or (not os.path.isfile(dbfile)):
		print 'ERROR: '+dbfile+'does not exist.'
		sys.exit()
	conn = sqlite3.connect(dbfile)
	with conn:
			features = fetchone(conn, select,(acc,pos,),0)
			#print """"""""
			#print features
	conn.close()
	return features

def get_residue_uniprot_annotation(accessions,positions):
	if len(accessions) < 1 or len(positions) <1:
		print 'Can not found any homology human sequence.'
		#sys.exit()	
		return []

	#features are mapped to SNP position
	ft = {}
	for i in range(len(accessions)):
		tmpFeatures = search_residue_uniprot_features(accessions[i],positions[i]) 
		if len(tmpFeatures) >0:
			for ftname in tmpFeatures:
				if ft.has_key(ftname):
					ft[ftname]+=1
				else:
					ft[ftname] = 1
	#print "*&*&*&*&*&*&*&*&*&*&*&*&*&*"
	#print ft
	return ft
