package buildDataFile;
import java.io.*;
import java.util.*;

import similarSearch.ResCharacter;
import model.*;

public class SplitResidueFile 
{
	public static char ssTypeTri(char c)
	{
		if(c == 'H' || c== 'G' || c=='I')
			return 'H';
		if(c == 'E')
			return 'E';
		return 'C';
	}
	
	public static void splitBySSSasa() throws IOException
	{
		
		
		char[] ss = {'H','E','C'};
		
		for(int i=0;i<3;i++)
		for(double sasa = 0.0;sasa<0.95;sasa+=0.1)
		{
			String fileName = ss[i]+"_"+String.format("%4.2f", sasa)+".txt";
			PrintStream out = new PrintStream("/mnt/0a/xiongpeng/java/data/residues2/splitBySSSasa/"+fileName);
			
			BufferedReader in = new BufferedReader(new FileReader("/mnt/0a/xiongpeng/java/data/residues2/residuesMED.txt"));
			String line;
			
			while((line = in.readLine())!=null)
			{
				if(line.length()<10)
					continue;
				
				char ssType = ssTypeTri(line.charAt(17));
				if(ssType != ss[i])
					continue;
				
				float sasaLine = Float.parseFloat(line.substring(38,43));
				float sasaLineN = ResCharacter.sasaAreaNormalize(sasaLine);
				
				if(sasaLineN < sasa || sasaLineN > sasa+0.1)
					continue;
				
				out.println(line);
			}
			in.close();
			out.close();
		}
	}
	
	public static void splitBySSSasaRT() throws IOException
	{
		
		
		char[] ss = {'H','E','C'};
		
		for(int i=0;i<3;i++)
		for(double sasa = 0.0;sasa<0.95;sasa+=0.1)
		{
			String fileName = ss[i]+"_"+String.format("%4.2f", sasa)+".txt";
			PrintStream out = new PrintStream("/mnt/0a/xiongpeng/java/data/residues2/splitBySSSasaRT/"+fileName);
			
			BufferedReader in = new BufferedReader(new FileReader("/mnt/0a/xiongpeng/java/data/residues2/residuesPSDRT.txt"));
			String line;
			
			while((line = in.readLine())!=null)
			{
				if(line.length()<10)
					continue;
				
				char ssType = ssTypeTri(line.charAt(17));
				if(ssType != ss[i])
					continue;
				
				float sasaLine = Float.parseFloat(line.substring(38,43));
				float sasaLineN = ResCharacter.sasaAreaNormalize(sasaLine);
				
				if(sasaLineN < sasa || sasaLineN > sasa+0.1)
					continue;
				
				out.println(line);
			}
			out.close();
			in.close();
		}
	}
	
	public static void main(String[] args) throws IOException
	{
	//	splitBySSSasa();
		splitBySSSasaRT();
	}
}
