package input;
import java.util.*;
import java.io.*;

public class InputFile 
{
	HashMap<String,String> inputFiles = new HashMap<String,String>();
	
	public InputFile(String fileList) throws IOException
	{
		String line;
		BufferedReader in = new BufferedReader(new FileReader(fileList));
		line = in.readLine();
		String[] spt0 = line.split(" +");
		if(spt0.length!=2)
		{
			in.close();
			throw new RuntimeException("input file list read error");
		}
		if(!spt0[0].equals("PATH"))
		{
			in.close();
			throw new RuntimeException("input file error, the first line must be PATH");
		}
		String path = spt0[1];
		while((line = in.readLine())!=null)
		{
			String[] spt = line.split(" +");
			if(spt.length!=2)
			{
				in.close();
				throw new RuntimeException("input file list read error");
			}
			this.inputFiles.put(spt[0], path+spt[1]);
		}
		in.close();
	}
	
	public InputFile() throws IOException
	{
		this("../dirLinux.txt");
	}
	
	public String get(String key)
	{
		if(this.inputFiles.containsKey(key))
			return this.inputFiles.get(key);
		else
			throw new RuntimeException("input file list read error");
	}
}
