package math;
import java.util.*;

public class CorrelationCoefficient {
		
	private static double sum(ArrayList<Double> list)
	{
		double sum = 0.0;
		for(Double x : list)
		{
			sum += x;
		}
		return sum;
	}
	
	public static double slope(ArrayList<Double> listA, ArrayList<Double> listB)
	{
		double meanA = Stat.mean(listA);
		double meanB = Stat.mean(listB);
		ArrayList<Double> mulAB = new ArrayList<Double>();
		ArrayList<Double> mulAA = new ArrayList<Double>();
		for(int i=0;i<listA.size();i++)
		{
			double a = listA.get(i);
			double b = listB.get(i);
			mulAB.add(a*b);
			mulAA.add(a*a);
		}
		int n = listA.size();
		double slope = (sum(mulAB)-n*meanA*meanB)/(sum(mulAA)-n*meanA*meanA);
		return slope;
	}
	
	public static double rmse(ArrayList<Double> listA, ArrayList<Double> listB)
	{
		double eeSum = 0;
		for(int i=0;i<listA.size();i++)
		{
			double err = listA.get(i) - listB.get(i);
			eeSum += err*err;
		}
		return Math.sqrt(eeSum/listA.size());
	}
	
	public static double correlation(ArrayList<Double> listA, ArrayList<Double> listB)
	{
		if(listA.size() == 0) 
			throw new RuntimeException("empty array");
		if(listA.size() != listB.size())
			throw new RuntimeException("size not equal");
		ArrayList<Double> mulAB = new ArrayList<Double>();
		ArrayList<Double> mulAA = new ArrayList<Double>();
		ArrayList<Double> mulBB = new ArrayList<Double>();
		for(int i=0;i<listA.size();i++)
		{
			double a = listA.get(i);
			double b = listB.get(i);
			mulAB.add(a*b);
			mulAA.add(a*a);
			mulBB.add(b*b);
		}
		double sumA = sum(listA);
		double sumB = sum(listB);
		double sumAA = sum(mulAA);
		double sumBB = sum(mulBB);
		double sumAB = sum(mulAB);
		int n = listA.size();
		double r = (n*sumAB-sumA*sumB)/Math.sqrt((n*sumAA-sumA*sumA)*(n*sumBB-sumB*sumB));
		return r;
	}
}
