package math;
import model.Tern;

public class Dihedral 
{
	public static double dihedral(Tern A, Tern B, Tern C, Tern D)
	{
		Tern BA = A.subtract(B);
		Tern CD = D.subtract(C);

		Tern BC = C.subtract(B);
		Tern CB = B.subtract(C);
		if(BA.length() ==0 || CD.length()==0 || BC.length()==0)
			throw new RuntimeException("bad input");
		Tern n1 = BA.cross(BC);
		n1 = n1.divide(n1.length());
//		System.out.println(n1.toString());
		Tern n2 = CB.cross(CD);
//		System.out.println(n2.toString());
		n2 = n2.divide(n2.length());
//		System.out.println(n2.toString());
		double angle = n1.angle(n2);
		double symbol = n1.cross(n2).dotProduct(BC);
		if(symbol!=0)
		{
			symbol = symbol/Math.abs(symbol);
			return angle*symbol;
		}
		return angle;
	}
	
	public static void main(String[] args)
	{
		Tern A = new Tern(1,0,0);
		Tern B = new Tern(0,0,0);
		Tern C = new Tern(0,1,0);
		Tern D = new Tern(-1,1,-0.1);
//		System.out.println(D.toString());
		double di = dihedral(A,B,C,D);
		System.out.println(di);
		
	}
}
