package model;

import java.util.*;

public class Atom implements Cloneable
{
	private String name;
	private String type;
	private Tern coordinate;
	
	public Atom()
	{
	}

	public Atom(String name)
	{
		this.name=name;
		this.type=name;
		if(name.length()>1)
		{
			this.type=name.substring(0,1);
		}
		this.coordinate=new Tern();
	}
	
	public Atom(String name,String type)
	{
		this.name=name;
		this.type=type;
		this.coordinate=new Tern();
	}
	
	public Atom(Tern coor)
	{
		this.coordinate=coor;
		this.name="atom";
	}
	
	public Atom(String name,float x,float y,float z)
	{
		this.name=name;
		this.type=name;
		if(name.length()>1)
		{
			this.type=name.substring(0,1);
		}
		this.coordinate=new Tern(x,y,z);
	}
	
	public Atom(String name,Tern coor)
	{
		this.name=name;
		this.type=name;
		if(name.length()>1)
		{
			this.type=name.substring(0,1);
		}
		this.coordinate=coor;
	}
	
	public String getName()
	{
		return this.name;
	}
	
	public String getType()
	{
		return this.type;
	}
	
	public Tern getCoordinate()
	{
		float x=this.coordinate.x();
		float y=this.coordinate.y();
		float z=this.coordinate.z();
		Tern coordinate=new Tern(x,y,z);
		return coordinate;
	}
	
	public void setName(String name)
	{
		this.name=name;
	}
	
	public void setType(String type)
	{
		this.type=type;
	}
	
	public void setCoordinate(Tern other)
	{
		this.coordinate=other;
	}
	
	public void setCoordinate(float x,float y,float z)
	{
		this.coordinate=new Tern(x,y,z);
	}
	
	public String toString()
	{
		String str=this.name+" "+this.coordinate.toString()+" "+this.type;
		return str;
	}
	
	public float distance(Atom other)
	{
		float len=this.coordinate.distance(other.getCoordinate());
		return len;
	}
	
	public Atom clone()
	{
		Atom copyA=new Atom(this.name,this.coordinate);
		copyA.type=this.getType();
		
		return copyA;	
	}
	
	public float atomWeight()
	{
		Map<String,Float> atomW=new HashMap<String,Float>();
		atomW.put("C", 12.017f);
		atomW.put("N", 14.0067f);
		atomW.put("O",15.9994f);
		atomW.put("S", 32.065f);
		atomW.put("P", 30.973762f);
		atomW.put("H", 1.00794f);
		
		if(atomW.containsKey(this.type))
		{
			return atomW.get(this.type);
		}
		else
		{
			return 0;
		}

	}
}
