package model;
import java.util.*;

public class ResName 
{
	private String triName;
	private char sinName;
	
	public ResName(char single)
	{
		this.sinName=single;
		this.triName=sinToTri(single);
	}
	
	public ResName(String triple)
	{
		this.sinName=triToSin(triple);
		this.triName=triple;
	}
	
	public String getTriName()
	{
		return this.triName;
	}
	
	public char getSinName()
	{
		return this.sinName;
	}
	
	public static char triToSin(String triple)
	{
		HashMap<String,Character> triToSinMap = new HashMap<String,Character>();
		triToSinMap.put("ALA", 'A');
		triToSinMap.put("CYS", 'C');
		triToSinMap.put("ASP", 'D');
		triToSinMap.put("GLU", 'E');
		triToSinMap.put("PHE", 'F');
		triToSinMap.put("GLY", 'G');
		triToSinMap.put("HIS", 'H');
		triToSinMap.put("ILE", 'I');
		triToSinMap.put("LYS", 'K');
		triToSinMap.put("LEU", 'L');
		triToSinMap.put("MET", 'M');
		triToSinMap.put("ASN", 'N');
		triToSinMap.put("PRO", 'P');
		triToSinMap.put("GLN", 'Q');
		triToSinMap.put("ARG", 'R');
		triToSinMap.put("SER", 'S');
		triToSinMap.put("THR", 'T');
		triToSinMap.put("VAL", 'V');
		triToSinMap.put("TRP", 'W');
		triToSinMap.put("TYR", 'Y');
		if(triToSinMap.containsKey(triple))
			return triToSinMap.get(triple);
//		System.err.println("can't find residue name :"+triple);
		
		return 'X';		
	}
	
	public static char triToSin(String triple, HashMap<String,Character> triToSinMap)
	{
		if(triToSinMap.containsKey(triple))
			return triToSinMap.get(triple);
//		System.err.println("can't find residue name :"+triple);
		return 'X';		
	}
	
	public static int triToInt(String triple)
	{
		HashMap<String,Integer> triToIntMap = new HashMap<String,Integer>();
		triToIntMap.put("ALA", 0);
		triToIntMap.put("CYS", 1);
		triToIntMap.put("ASP", 2);
		triToIntMap.put("GLU", 3);
		triToIntMap.put("PHE", 4);
		triToIntMap.put("GLY", 5);
		triToIntMap.put("HIS", 6);
		triToIntMap.put("ILE", 7);
		triToIntMap.put("LYS", 8);
		triToIntMap.put("LEU", 9);
		triToIntMap.put("MET", 10);
		triToIntMap.put("ASN", 11);
		triToIntMap.put("PRO", 12);
		triToIntMap.put("GLN", 13);
		triToIntMap.put("ARG", 14);
		triToIntMap.put("SER", 15);
		triToIntMap.put("THR", 16);
		triToIntMap.put("VAL", 17);
		triToIntMap.put("TRP", 18);
		triToIntMap.put("TYR", 19);
		if(triToIntMap.containsKey(triple))
		{
			return triToIntMap.get(triple);
		}
//		System.err.println("can't find residue name :"+triple);
		return -1;
	}
	
	public static String intToTri(int i)
	{
		HashMap<Integer,String> intToTriMap=new HashMap<Integer,String>();
		intToTriMap.put(0,"ALA");
		intToTriMap.put(1,"CYS");
		intToTriMap.put(2,"ASP");
		intToTriMap.put(3,"GLU");		
		intToTriMap.put(4,"PHE");
		intToTriMap.put(5,"GLY");
		intToTriMap.put(6,"HIS");
		intToTriMap.put(7,"ILE");
		intToTriMap.put(8,"LYS");
		intToTriMap.put(9,"LEU");
		intToTriMap.put(10,"MET");
		intToTriMap.put(11,"ASN");
		intToTriMap.put(12,"PRO");
		intToTriMap.put(13,"GLN");
		intToTriMap.put(14,"ARG");
		intToTriMap.put(15,"SER");
		intToTriMap.put(16,"THR");
		intToTriMap.put(17,"VAL");
		intToTriMap.put(18,"TRP");
		intToTriMap.put(19,"TYR");
		if(intToTriMap.containsKey(i))
			return intToTriMap.get(i);
//		System.err.println("i should be less than 20, but i=" + i);
		return "XXX";
	}
	public static boolean isResName(String triple)
	{
		return (triToSin(triple)!='X');
	}
	
	public static boolean isResName(String triple, HashMap<String,Character> map)
	{
		return (triToSin(triple,map)!='X');
	}
	
	public static boolean isResName(char single)
	{
		return (!sinToTri(single).equals("XXX"));
	}
	
	public static String sinToTri(char single)
	{
		HashMap<Character,String> sinToTriMap=new HashMap<Character,String>();
		sinToTriMap.put('A', "ALA");
		sinToTriMap.put('C', "CYS");
		sinToTriMap.put('D', "ASP");
		sinToTriMap.put('E', "GLU");
		sinToTriMap.put('F', "PHE");
		sinToTriMap.put('G', "GLY");
		sinToTriMap.put('H', "HIS");
		sinToTriMap.put('I', "ILE");
		sinToTriMap.put('K', "LYS");
		sinToTriMap.put('L', "LEU");
		sinToTriMap.put('M', "MET");
		sinToTriMap.put('N', "ASN");
		sinToTriMap.put('P', "PRO");
		sinToTriMap.put('Q', "GLN");
		sinToTriMap.put('R', "ARG");
		sinToTriMap.put('S', "SER");
		sinToTriMap.put('T', "THR");
		sinToTriMap.put('V', "VAL");
		sinToTriMap.put('W', "TRP");
		sinToTriMap.put('Y', "TYR");
		if(sinToTriMap.containsKey(single))
			return sinToTriMap.get(single);
//		System.err.println("can't find residue name : "+single);
		
		return "XXX";
	}
	public static char intToSin(int i)
	{
		String tri=ResName.intToTri(i);
		return ResName.triToSin(tri);
	}
	public static int sinToInt(char single)
	{
		String triple=ResName.sinToTri(single);
		return ResName.triToInt(triple);
	}
	
	
}
