package model;
import java.util.*;
import java.io.*;
import math.ProbabilityArrayRT;

public class Rotamers 
{
	private int[] resRotamerNum = new int[20];
	private int rotamerDefLevel;
	private int totalRotamerNum;
	private double[] richness;
	
	public Rotamers(int rotamerDefLevel) throws IOException
	{
		this.rotamerDefLevel = rotamerDefLevel;
		if(this.rotamerDefLevel == 1)
		{
			for(int i=0;i<20;i++)
			{
				if(i == 0 || i ==5)
					resRotamerNum[i] = 1;
				else if(i == 12)
					resRotamerNum[i] = 2;
				else if(i == 1 || i == 15 || i == 16 || i == 17)
					resRotamerNum[i] = 3;
				else if(i == 4 || i==6 || i==7 || i==9 || i==18 || i==19)
					resRotamerNum[i] = 9;
				else if(i==2 || i==11)
					resRotamerNum[i] = 18;
				else if(i==10)
					resRotamerNum[i] = 27;
				else if(i==3 || i==13)
					resRotamerNum[i] = 54;
				else if(i == 8 || i == 14)
					resRotamerNum[i] = 81;
			}
		}
		else if(this.rotamerDefLevel == 2)
		{
			for(int i=0;i<20;i++)
			{
				if(i == 0 || i ==5)
					resRotamerNum[i] = 1;
				else if(i == 12)
					resRotamerNum[i] = 2;
				else if(i == 1 || i==15 || i==16 || i==17)
					resRotamerNum[i] = 3;
				else if(i==2 || i==11)
					resRotamerNum[i] = 18;
				else 
					resRotamerNum[i] = 9;
			}
		}
		else if(this.rotamerDefLevel == 3)
		{
			for(int i=0;i<20;i++)
			{
				if(i == 0 || i ==5)
					resRotamerNum[i] = 1;
				else if(i == 12)
					resRotamerNum[i] = 2;
				else if(i == 3 || i==8 || i==10 || i==13 || i==14)
					resRotamerNum[i] = 9;
				else
					resRotamerNum[i] = 3;
			}
		}
		else if(this.rotamerDefLevel == 4)
		{
			for(int i=0;i<20;i++)
			{
				if(i == 0 || i ==5)
					resRotamerNum[i] = 1;
				else if(i == 12)
					resRotamerNum[i] = 2;
				else
					resRotamerNum[i] = 3;
			}
		}
		else if(this.rotamerDefLevel == 5)
		{
			for(int i=0;i<20;i++)
			{
				if(i == 0 || i ==5)
					resRotamerNum[i] = 1;
				else if(i == 12)
					resRotamerNum[i] = 2;
				else if(i == 3 || i==7 || i==8 || i==9 || i==13 || i==14)
					resRotamerNum[i] = 9;
				else
					resRotamerNum[i] = 3;
			}
		}
		else if(this.rotamerDefLevel == 6)
		{
			for(int i=0;i<20;i++)
			{
				if(i == 0 || i ==5)
					resRotamerNum[i] = 1;
				else if(i == 12)
					resRotamerNum[i] = 2;
				else if(i == 3 ||  i==8  || i==13 || i==14)
					resRotamerNum[i] = 9;
				else
					resRotamerNum[i] = 3;
			}
		}

		
		int total = 0;
		for(int i=0;i<20;i++)
		{
			total += this.resRotamerNum[i];
		}
		this.totalRotamerNum = total;
		
		this.richness = new double[this.totalRotamerNum];
		ProbabilityArrayRT pb = ProbabilityArrayRT.getPB(this.rotamerDefLevel);
		double[] aaRichness = new double[20];
		int rotFlag = 0;
		for(int i=0;i<20;i++)
		{
			for(int j=0;j<this.resRotamerNum[i];j++)
			{
				aaRichness[i] += pb.getArray().get(rotFlag);
				rotFlag ++;
			}
		}
		rotFlag = 0;
		for(int i=0;i<20;i++)
		{
			for(int j=0;j<this.resRotamerNum[i];j++)
			{
				richness[rotFlag] = pb.getArray().get(rotFlag)/aaRichness[i];
				rotFlag ++;
			}
		}
	}
	
	public int rotamerNum()
	{
		return this.totalRotamerNum;
	}
	
	public int rotmerLevel()
	{
		return this.rotamerDefLevel;
	}
	
	public double[] richness()
	{
		return this.richness;
	}
	
	public static int rotmerNumToLevel(int rotNum)
	{
		if(rotNum == 403)
			return 1;
		if(rotNum == 151)
			return 2;
		if(rotNum == 85)
			return 3;
		if(rotNum == 55)
			return 4;
		if(rotNum == 91)
			return 5;
		if(rotNum == 79)
			return 6;
		else
			throw new RuntimeException("undefined rotmer number\n");
	}
	
	public int getAminoAcidRotamerNum(int resName)
	{
		return this.resRotamerNum[resName];
	}
	
	public ArrayList<Integer> getAminoAcidRotamerID(int resName)
	{
		ArrayList<Integer> list = new ArrayList<Integer>();
		int s=0;
		for(int i=0;i<resName;i++)
		{
			s += this.resRotamerNum[i];
		}
		for(int i=0;i<this.resRotamerNum[resName];i++)
		{
			list.add(s+i);
		}
		return list;
	}
	
	public int dunbrackCodeToInt(String s)
	{
		ArrayList<Integer> dunClassList = new ArrayList<Integer>();
		for(int i=0;i<4;i++)
		{
			if(s.charAt(i+3)>='1' && s.charAt(i+3)<='6')
				dunClassList.add(s.charAt(i+3)-'0');
		}
		return dunbrackCodeToInt(s.substring(0, 3),dunClassList);
	}
	
	public int dunbrackCodeToInt(String triName, ArrayList<Integer> dunClassList)
	{
		int resNameInt = ResName.triToInt(triName);
		if(resNameInt < 0)
			throw new RuntimeException("res name error: " + triName);
		int front = 0;
		for(int i=0;i<resNameInt;i++)
		{
			front += getAminoAcidRotamerNum(i);
		}
		int thisResRotNum = getAminoAcidRotamerNum(resNameInt);
		int rank = 0;
		if(thisResRotNum == 1)
		{
			rank = 0;
		}
		else if(thisResRotNum <= 3)
		{
			if(dunClassList.size()< 1)
				return front+1;
			rank = dunClassList.get(0)-1;
		}
		else if(thisResRotNum == 9)
		{
			if(dunClassList.size()<2)
				return -1;
			rank = (dunClassList.get(0)-1)*3 + dunClassList.get(1)-1;
		}
		else if(thisResRotNum == 18)
		{
			if(dunClassList.size()<2)
				return -1;
			rank = (dunClassList.get(0)-1)*6 + dunClassList.get(1)-1;
		}
		else if(thisResRotNum == 27)
		{
			if(dunClassList.size()<3)
				return -1;
			rank = (dunClassList.get(0)-1)*9 + (dunClassList.get(1)-1)*3 + dunClassList.get(2)-1;
		}
		else if(thisResRotNum == 54)
		{
			if(dunClassList.size()<3)
				return -1;
			rank = (dunClassList.get(0)-1)*18 + (dunClassList.get(1)-1)*6 + dunClassList.get(2)-1;
		}
		else if(thisResRotNum == 81)
		{
			if(dunClassList.size()<4)
				return -1;
			rank = (dunClassList.get(0)-1)*27 + (dunClassList.get(1)-1)*9 + (dunClassList.get(2)-1)*3 + dunClassList.get(3)-1;
		}
		else throw new RuntimeException("undefined rotemer Number " + thisResRotNum);
		return front+rank;
	}
	
	public String intToDunbrackCode(int i)
	{
		if(i >= this.totalRotamerNum)
			throw new RuntimeException("index out of range: i = "+i);
		int sum=0;
		int k;
		for(k=0;k<20;k++)
		{
			sum += this.resRotamerNum[k];
			if(sum  > i)
				break;
		}
		
		int rank = i-sum+this.resRotamerNum[k];
		String dunCode = ResName.intToTri(k);
		int resRotNum = this.resRotamerNum[k];
		if(resRotNum <= 3)
		{
			int first = rank +1;
			dunCode = dunCode + first + "000";
		}
		else if(resRotNum == 9)
		{
			int first = rank/3+1;
			int second = rank%3 +1;
			dunCode = dunCode + first + second + "00";
		}
		else if(resRotNum == 18)
		{
			int first = rank/6 +1;
			int second = rank%6 +1;
			dunCode = dunCode + first + second + "00";
		}
		else if(resRotNum == 27)
		{
			int first = rank/9+1;
			int second = (rank - (first-1)*9)/3+1;
			int third = rank%3 +1;
			dunCode = dunCode + first + second + third + "0";
		}
		else if(resRotNum == 54)
		{
			int first = rank/18 +1;
			int second = rank%18/6 + 1;
			int third = rank%6 + 1;
			dunCode = dunCode + first + second + third + "0";
		}
		else if(resRotNum == 81)
		{
			int first = rank/27 + 1;
			int second = rank%27/9 + 1;
			int third = rank%9/3 +1;
			int fouth = rank%3 + 1;
			dunCode = dunCode + first + second + third + fouth;
		}
		return dunCode;
	}
	
	public static void main(String[] args) throws IOException
	{
		Rotamers rots = new Rotamers(4);
//		System.out.println(rots.totalRotamerNum);
		
		String r1 = "GLU1220";
		System.out.println(rots.dunbrackCodeToInt(r1));
		
		for(int i=0;i<55;i++)
		{
			String dunCode = rots.intToDunbrackCode(i);
			ArrayList<Integer> list = new ArrayList<Integer>();
			for(int j=3;j<7;j++)
			{
				if(dunCode.charAt(j)<='6' && dunCode.charAt(j)>='1')
					list.add(dunCode.charAt(j) - '0');
			}
			int j = rots.dunbrackCodeToInt(dunCode.substring(0,3), list);
//			System.out.println(i + " " + dunCode + " " + j);
		}
		
		rots = new Rotamers(6);
		double[] r = rots.richness();
		for(int i=0;i<r.length;i++)
		{
			System.out.println(r[i]);
		}
		
		System.out.println(rots.intToDunbrackCode(64));
		System.out.println(rots.dunbrackCodeToInt("GLU3300"));
	}
}
