package model;

import java.io.*;

import java.util.ArrayList;
import java.util.HashMap;


public class StrideProtein 
{
	private ArrayList<StrideChain> chains;
	private HashMap<String,StrideRes> map = new HashMap<String,StrideRes>();
	
	public StrideProtein(String strideFile) throws IOException
	{
		BufferedReader in = new BufferedReader(new FileReader(strideFile));
		String line;
		this.chains=new ArrayList<StrideChain>();
		char lastChainID='#';
		StrideChain curChain = new StrideChain();
		while((line=in.readLine())!=null)
		{
			
			if(line.substring(0,3).equals("ASG"))
			{
				StrideRes res = new StrideRes(line);
				if(res.chainID!=lastChainID)
				{
					curChain=new StrideChain();
					curChain.setChainID(res.chainID);
					this.chains.add(curChain);
					lastChainID=res.chainID;
				}
				curChain.add(res);
			}
		}
		creatHashMap();
		in.close();
	}
	
	private void creatHashMap()
	{
		for(StrideChain chain : this.chains)
		{
			for(StrideRes res : chain.getResidues())
			{
				String key = ""+res.chainID+res.resID;
				this.map.put(key, res);
			}
		}
	}
	public StrideRes getStrideResidue(String chainIDresID)
	{
		if(this.map.containsKey(chainIDresID))
		{
			return this.map.get(chainIDresID);
		}
		return null;
//		throw new RuntimeException("can't not find stride Residue "+chainIDresID);
	}
	
	public ArrayList<StrideChain> getStrideChains()
	{
		return this.chains;
	}
	
	public StrideChain getChain(char chainID)
	{
		for(StrideChain sc : this.chains)
		{
			if(sc.getChainID()==chainID)
				return sc;
		}
		return null;
//		throw new RuntimeException("can't find chain "+chainID);
	}
	
	
}

