package model;
import input.InputFile;

import java.io.*;
import java.util.*;

public class VdwResPara {
	public final HashMap<String, HashMap<String, String>> vdwResAtomMap = new HashMap<String, HashMap<String,String>>();
	private VdwForceField vff = new VdwForceField();
	
	public VdwResPara() throws IOException
	{
		InputFile input = new InputFile();
		String resParaFile = input.get("RESPARAM_FILE");
				
		BufferedReader in = new BufferedReader(new FileReader(resParaFile));
		String line;
		
	
		do
		{
			line = in.readLine();
		} while(line.length()<5 || !line.substring(0,5).equals("START"));

	    boolean headerLine = true;    // next line should be header line
	    String resName = "";
		while(in.ready())
		{
			line = in.readLine();
			if(line.length()==0) continue;// blank line
			if(line.substring(0,4).equals("STOP")) break;

			if(line.substring(0,4).equals("done")) headerLine = true;
			else if(headerLine)
			{
				resName = line.substring(0, 3);
				this.vdwResAtomMap.put(resName, new HashMap<String,String>());
				this.vdwResAtomMap.get(resName).put("1H", "HN");
				this.vdwResAtomMap.get(resName).put("2H", "HN");
				this.vdwResAtomMap.get(resName).put("3H", "HN");
				
				
            	headerLine = false;
			}
			else
			{
				Scanner sc = new Scanner(line);
				sc.nextInt();
				String pdbAtomName = sc.next();
				String forceFieldAtomName = sc.next();
				this.vdwResAtomMap.get(resName).put(pdbAtomName, forceFieldAtomName);
				sc.close();
			}
		}
		in.close();
	}
	
	
	public VdwAtom getVdwAtom(String resName, String atomName)
	{
		HashMap<String,String> atomMap = this.vdwResAtomMap.get(resName);
		if(atomMap == null)
			throw new RuntimeException("unknown resName: " + resName);

		String vdwAtomName = atomMap.get(atomName);
		if(vdwAtomName == null)
			throw new RuntimeException("unknow atomName: " + resName + " " + atomName);
		
		return vff.vdwAtomMap.get(vdwAtomName);
	}
	
}
