package sequence;
import input.InputFile;

import java.io.*;
import java.util.Scanner;

import model.ResName;

public class AccurateBlosum62
{
	private double[][] score=new double[20][20];
	private double[] pa = new double[20];
	
	public AccurateBlosum62() throws IOException
	{
		InputFile inputFiles = new InputFile();
		String blosumFile = inputFiles.get("blosum62Double");
		BufferedReader in = new BufferedReader(new FileReader(blosumFile));
		String line;
		int i=-1;
		while((line=in.readLine())!=null)
		{
			if(line.length() < 2)
				continue;
			if(line.charAt(0)=='#'||line.charAt(0)==' ')
			{
				continue;
			}
			else if(line.charAt(0) == '@')
			{
				Scanner sc = new Scanner(line);
				sc.next();
				for(int j=0;j<20;j++)
					this.pa[j] = sc.nextDouble();
				sc.close();
				continue;
			}
			Scanner sc = new Scanner(line);
			i++;
			sc.next();
					
			for(int j=0;j<20;j++)
			{
				score[i][j]=sc.nextDouble();
			}
			sc.close();
		}
		in.close();
	}
	
	
	public AccurateBlosum62(String file) throws IOException
	{
		String blosumFile = file;
		BufferedReader in = new BufferedReader(new FileReader(blosumFile));
		String line;
		int i=-1;
		while((line=in.readLine())!=null)
		{
			if(line.length() < 2)
				continue;
			if(line.charAt(0)=='#'||line.charAt(0)==' ')
			{
				continue;
			}
			else if(line.charAt(0) == '@')
			{
				Scanner sc = new Scanner(line);
				sc.next();
				for(int j=0;j<20;j++)
					this.pa[j] = sc.nextDouble();
				sc.close();
				continue;
			}
			Scanner sc = new Scanner(line);
			i++;
			sc.next();
					
			for(int j=0;j<20;j++)
			{
				score[i][j]=sc.nextDouble();
			}
			sc.close();
		}
		in.close();
	}
	
	public double getScore(char a,char b)
	{
		//
		
		return this.score[ResName.sinToInt(a)][ResName.sinToInt(b)];
	}
	
	public double getScore(int i, int j)
	{
		return this.score[i][j];
	}
	
	public double getPA(int i)
	{
		return this.pa[i];
	}
	
	public int getScore(String a,String b)
	{
		if(a.length()!=b.length())
		{
			throw new RuntimeException(a.length()+","+b.length()+" sequence length not equal");
		}
		int score=0;
		for(int i=0;i<a.length();i++)
		{
			score+=getScore(a.charAt(i),b.charAt(i));
		}
		return score;
	}
	
	public static void main(String[] args) throws IOException
	{
		AccurateBlosum62 bl = new AccurateBlosum62();
		for(int i=0;i<20;i++)
		{
			
			for(int j=0;j<20;j++)
			{
				double s = bl.getScore(i, j);
				System.out.printf("%6.3f ",s);
			}
			System.out.println();
		}
	}
	
}