package sequence;

import java.io.IOException;

import math.ProbabilityArray;

public class XProfile 
{
	private double[] p = new double[20];
	private double[] logP = new double[20];
	private ProbabilityArray pa;
	
	public XProfile(ProbabilityArray pa, int idt) throws IOException
	{
		SubstitutionMatrix stm = new SubstitutionMatrix(idt);
		ProbabilityArray pb = pa.applySubstitution(stm);
		this.pa = pb;
		for(int i=0;i<20;i++)
		{
			p[i] = pb.getArray().get(i);
			logP[i] = Math.log(p[i]);
		}
	}
	
	public double[] getP()
	{
		return this.p;
	}
	
	public double[] getLogP()
	{
		return this.logP;
	}
	
	public ProbabilityArray getPA()
	{
		return this.pa;
	}
}
