package similarSearch;
import java.io.*;
import java.util.*;

import model.ResName;
import input.InputFile;
public class BackgroundFasta 
{
	private HashMap<String,ArrayList<String>> fastaMap = new HashMap<String,ArrayList<String>>();
	private int shuffledSequenceNum;
	
	public BackgroundFasta(String fileType,int seqNum) throws IOException
	{
		this.shuffledSequenceNum = seqNum;
		InputFile input = new InputFile();
		String fileName = "";
		if(fileType.equals("S1ShuffleFasta10"))
		{
			fileName = input.get("S1ShuffleFasta10");
		}
		else if(fileType.equals("S1S2ShuffleFasta10"))
		{
			fileName = input.get("S1S2ShuffleFasta10");
		}
		else if(fileType.equals("S1ShuffleFasta100"))
		{
			fileName = input.get("S1ShuffleFasta100");
		}
		else if(fileType.equals("S1ShuffleFasta100T0.5"))
		{
			fileName = input.get("S1ShuffleFasta100T0.5");
		}
		else if(fileType.equals("S1S2ShuffleFasta100"))
		{
			fileName = input.get("S1S2ShuffleFasta100");
		}
		else 
		{
			throw new RuntimeException("unknown shuffle type: " + fileType);
		}
		
		BufferedReader in = new BufferedReader(new FileReader(fileName));
		String line;
		while((line = in.readLine())!=null)
		{
			if(line.length() < 2)
			{
				continue;
			}
			if(line.charAt(0) == '>')
			{
				String pdbIDChainID = line.substring(1,6);
				ArrayList<String> seqs = new ArrayList<String>();
				for(int i=0;i<seqNum;i++)
				{
					line = in.readLine();
					if(line.charAt(0)=='>')
						throw new RuntimeException("fasta seq read error ");
					seqs.add(line.trim());
					
				}
				this.fastaMap.put(pdbIDChainID, seqs);
			}
		}
	}
	
	public int seqNumForEachPDB()
	{
		return this.shuffledSequenceNum;
	}
	
	public boolean contains(String pdbID, char chainID)
	{
		String key = pdbID.toLowerCase()+chainID;
		return this.fastaMap.containsKey(key);
	}
	
	public int getResType(String pdbID, char chainID, int resIDSD,int seqID)
	{
		char resType = this.fastaMap.get(pdbID+chainID).get(seqID).charAt(resIDSD);
		return ResName.sinToInt(resType);
	}
}
