package similarSearch;
import input.InputFile;

import java.util.*;
import java.io.*;

import sequence.*;

public class FindBanListInterface
{
	public static HashMap<String,String> getAllSeqs(String file) throws IOException
	{
		BufferedReader in = new BufferedReader(new FileReader(file));
		String line;
		HashMap<String,String> map = new HashMap<String,String>();
		while((line = in.readLine())!=null)
		{
			if(line.length()<5)
				continue;
			String[] spt = line.trim().split(" +");
			map.put(spt[0], spt[1]);
		}
		in.close();
		return map;
	}
	
	public static HashSet<String> getBanList(String seqA, String seqB, double idtCutoff) throws IOException
	{
		HashMap<String,String> map = getAllSeqs("/nfs/amino-home/pengx/ABACUS/data/piface.select.seq");
		ArrayList<String> pairList = usr.FileToList.getList("/nfs/amino-home/pengx/ABACUS/data/piList.all");
		
		HashSet<String> banPDB = new HashSet<String>();
		Blosum62 blosum62 = new Blosum62();
		for(String pi : pairList)
		{
			String chainA = pi.substring(0, 4) + pi.charAt(5);
			String chainB = pi.substring(0, 4) + pi.charAt(7);
			String dSeqA = map.get(chainA);
			String dSeqB = map.get(chainB);
			double idtAA = SeqAlign.localIdentity(seqA, dSeqA, blosum62);
			double idtAB = SeqAlign.localIdentity(seqA, dSeqB, blosum62);
			if(idtAA < 0.3 && idtAB < 0.3) continue;
			double idtBA = SeqAlign.localIdentity(seqB, dSeqA, blosum62);
			double idtBB = SeqAlign.localIdentity(seqB, dSeqB, blosum62);
			
			if(idtAA > idtCutoff && idtBB > idtCutoff || idtAB > idtCutoff && idtBA > idtCutoff)
			{
				banPDB.add(pi.substring(0, 4));
			}
		}
		return banPDB;
	}
	
	public static void main(String[] args) throws IOException
	{
		
		
	}
}
