package similarSearch;
import model.*;
import input.InputFile;

import java.io.*;
import java.util.*;

import math.*;
import buildDataFile.SplitResidueFile;


public class FindSimilarPairsRT 
{
	public static ArrayList<String> getFileList(ResPair rp, PairPara pPr) throws IOException
	{
		InputFile inputFiles = new InputFile();
		ArrayList<String> pairFiles= new ArrayList<String>();
		if(Math.abs(rp.seqDistance())>3)
		{
			String path = inputFiles.get("splitBySSandSASART");
			File pairFilePath = new File(path);
			for(String s : pairFilePath.list())
			{
				char ssTypeA = s.charAt(0);
				char ssTypeB = s.charAt(1);
				double sasaALow = Double.parseDouble(s.substring(2,5));
				double sasaAHigh = sasaALow + 0.1;
				
				double sasaBLow = Double.parseDouble(s.substring(6,9));
				double sasaBHigh = sasaBLow + 0.1;
				if(!ResCharacter.simSecondaryStructure(ssTypeA, SplitResidueFile.ssTypeTri(rp.strResA.ssType), pPr.resParaA().ssLevel()))
					continue;
				if(!ResCharacter.simSecondaryStructure(ssTypeB, SplitResidueFile.ssTypeTri(rp.strResB.ssType), pPr.resParaA().ssLevel()))
					continue;
		
				double sasaAN=ResCharacter.sasaAreaNormalize(rp.strResA.area);
				double sasaBN=ResCharacter.sasaAreaNormalize(rp.strResB.area);
				
				
				if(sasaAN > sasaALow && sasaAN < sasaAHigh && sasaBN > sasaBLow && sasaBN < sasaBHigh)
					pairFiles.add(path+s);
				else if(ResCharacter.simSasaN(sasaALow, sasaAN, pPr.resParaA().sasaLevel()) || ResCharacter.simSasaN(sasaAHigh, sasaAN, pPr.resParaA().sasaLevel()))
				{
					if(ResCharacter.simSasaN(sasaBLow, sasaBN, pPr.resParaA().sasaLevel()) || ResCharacter.simSasaN(sasaBHigh, sasaBN, pPr.resParaA().sasaLevel()))
						pairFiles.add(path+s);
				}
					
			}
		}
		else 
		{
			
			String path = inputFiles.get("neighborRT");		
			File pairFilePath = new File(path);
			int seqDis = rp.seqDistance();
			double sasaAN = ResCharacter.sasaAreaNormalize(rp.strResA.area);
			double sasaBN = ResCharacter.sasaAreaNormalize(rp.strResB.area);
			for(String s : pairFilePath.list())
			{
				
				int fileDis = Integer.parseInt(s.substring(2,3));
				if(fileDis != seqDis)
					continue;
				double sasaALow = Double.parseDouble(s.substring(4,7));
				
				double sasaAHigh = sasaALow + 0.1;
				double sasaBLow = Double.parseDouble(s.substring(8,11));
				double sasaBHigh = sasaBLow + 0.1;
				if(sasaAN > sasaALow && sasaAN < sasaAHigh && sasaBN > sasaBLow && sasaBN < sasaBHigh)
					pairFiles.add(path+s);
				else if(ResCharacter.simSasaN(sasaALow, sasaAN, pPr.resParaA().sasaLevel()) || ResCharacter.simSasaN(sasaAHigh, sasaAN, pPr.resParaA().sasaLevel()))
				{
					if(ResCharacter.simSasaN(sasaBLow, sasaBN, pPr.resParaA().sasaLevel()) || ResCharacter.simSasaN(sasaBHigh, sasaBN, pPr.resParaA().sasaLevel()))
						pairFiles.add(path+s);
				}
			}
		}
		return pairFiles;
	}
	
	public static ArrayList<String> getFileList(RotPair rp, PairPara pPr) throws IOException
	{
		InputFile inputFiles = new InputFile();
		ArrayList<String> pairFiles= new ArrayList<String>();
		if(Math.abs(rp.seqDistance())>3)
		{
			String path = inputFiles.get("rotPair");
			File pairFilePath = new File(path);
			for(String s : pairFilePath.list())
			{
				char ssTypeA = s.charAt(0);
				char ssTypeB = s.charAt(1);
//				System.out.println(s);
				double sasaALow = Double.parseDouble(s.substring(2,5));
				double sasaAHigh = sasaALow + 0.1;
				
				double sasaBLow = Double.parseDouble(s.substring(6,9));
				double sasaBHigh = sasaBLow + 0.1;
				StrideRes sr = rp.strResA;
				if(sr == null)
				{
					System.out.println("no sr information " + rp.getResA().getIDSD());
				}
//				System.out.println(sr.ssType);
//				char rpSSA = SplitResidueFile.ssTypeTri(rp.strResA.ssType);
//				int ssLevel =  pPr.resParaA().ssLevel();
				if(!ResCharacter.simSecondaryStructure(ssTypeA, SplitResidueFile.ssTypeTri(rp.strResA.ssType), pPr.resParaA().ssLevel()))
					continue;
				if(!ResCharacter.simSecondaryStructure(ssTypeB, SplitResidueFile.ssTypeTri(rp.strResB.ssType), pPr.resParaA().ssLevel()))
					continue;
		
				double sasaAN=ResCharacter.sasaAreaNormalize(rp.strResA.area);
				double sasaBN=ResCharacter.sasaAreaNormalize(rp.strResB.area);
				
				
				if(sasaAN > sasaALow && sasaAN < sasaAHigh && sasaBN > sasaBLow && sasaBN < sasaBHigh)
					pairFiles.add(path+s);
				else if(ResCharacter.simSasaN(sasaALow, sasaAN, pPr.resParaA().sasaLevel()) || ResCharacter.simSasaN(sasaAHigh, sasaAN, pPr.resParaA().sasaLevel()))
				{
					if(ResCharacter.simSasaN(sasaBLow, sasaBN, pPr.resParaA().sasaLevel()) || ResCharacter.simSasaN(sasaBHigh, sasaBN, pPr.resParaA().sasaLevel()))
						pairFiles.add(path+s);
				}
					
			}
		}
		else 
		{
			
			String path = inputFiles.get("rotNeighbor");		
			File pairFilePath = new File(path);
			int seqDis = rp.seqDistance();
			double sasaAN = ResCharacter.sasaAreaNormalize(rp.strResA.area);
			double sasaBN = ResCharacter.sasaAreaNormalize(rp.strResB.area);
			for(String s : pairFilePath.list())
			{
				
				int fileDis = Integer.parseInt(s.substring(2,3));
				if(fileDis != seqDis)
					continue;
				double sasaALow = Double.parseDouble(s.substring(4,7));
				
				double sasaAHigh = sasaALow + 0.1;
				double sasaBLow = Double.parseDouble(s.substring(8,11));
				double sasaBHigh = sasaBLow + 0.1;
				if(sasaAN > sasaALow && sasaAN < sasaAHigh && sasaBN > sasaBLow && sasaBN < sasaBHigh)
					pairFiles.add(path+s);
				else if(ResCharacter.simSasaN(sasaALow, sasaAN, pPr.resParaA().sasaLevel()) || ResCharacter.simSasaN(sasaAHigh, sasaAN, pPr.resParaA().sasaLevel()))
				{
					if(ResCharacter.simSasaN(sasaBLow, sasaBN, pPr.resParaA().sasaLevel()) || ResCharacter.simSasaN(sasaBHigh, sasaBN, pPr.resParaA().sasaLevel()))
						pairFiles.add(path+s);
				}
			}
		}
		return pairFiles;
	}
	
	public static ArrayList<Integer> dunbrackCode(String s)
	{
		if(s.length() != 4)
			throw new RuntimeException("error: " + s.length());
		ArrayList<Integer> intList = new ArrayList<Integer>();
		for(int i=0;i<4;i++)
		{
			if(s.charAt(i)<='6' && s.charAt(i)>='1')
			{
				intList.add(s.charAt(i) - '0');
			}
		}
		return intList;
	}
	
	
	
	public static ProbabilityMatrix findPMofPair(RotPair rp, PairPara pPr,HashSet<String> banPDB) throws IOException
	{
		double[][] pMatrix=new double[20][20];
		ArrayList<String> files = getFileList(rp, pPr);
		int foundPairNum=0;
		for(String s : files)
		{
			BufferedReader in = new BufferedReader(new FileReader(s));
			String line;
			while((line=in.readLine())!=null)
			{
				StrideRes strA=new StrideRes(line.charAt(202),Float.parseFloat(line.substring(205,212).trim()),Float.parseFloat(line.substring(214,221).trim()),Float.parseFloat(line.substring(223,228).trim()));
				if(!strA.similarTo(rp.strResA, pPr.resParaA()))
					continue;
				StrideRes strB=new StrideRes(line.charAt(229),Float.parseFloat(line.substring(232,239).trim()),Float.parseFloat(line.substring(241,248).trim()),Float.parseFloat(line.substring(250,255).trim()));
				if(!strB.similarTo(rp.strResB, pPr.resParaB()))
					continue;
				if(banPDB.contains(line.substring(0,4).toLowerCase()))
					continue;
				
				double rmsd = rp.rmsd(line);
				
				double rmsdCutoff = pPr.cutoff(rp);
				
				if(rmsd>rmsdCutoff)
					continue;
				
				

				String resAName = line.substring(13,16);
				String resBName = line.substring(26,29);
				
				
				foundPairNum++;
				pMatrix[ResName.triToInt(resAName)][ResName.triToInt(resBName)]+=1.0;
			}
			

			in.close();
		}
		ProbabilityMatrix pm = new ProbabilityMatrix(pMatrix,foundPairNum);
		if(rp.strResB.resID-rp.strResA.resID > 3)
		{
			ProbabilityMatrix mirrorPM = FindSimilarPairsRT.findPMofPair(rp.mirror(), pPr, banPDB);
			mirrorPM.transpose();
			pm=pm.merge(mirrorPM);
		}
		return pm;
	}
	
	public static ProbabilityMatrixRT findPMofRotPair(RotPair rp, PairPara pPr,HashSet<String> banPDB, Rotamers rots) throws IOException
	{
		double[][] pMatrix=new double[rots.rotamerNum()][rots.rotamerNum()];
		ArrayList<String> files = getFileList(rp, pPr);
		
		
		int foundPairNum=0;
		for(String s : files)
		{
			BufferedReader in = new BufferedReader(new FileReader(s));
			String line;
			while((line=in.readLine())!=null)
			{
				StrideRes strA=new StrideRes(line.charAt(202),Float.parseFloat(line.substring(205,212).trim()),Float.parseFloat(line.substring(214,221).trim()),Float.parseFloat(line.substring(223,228).trim()));
				if(!strA.similarTo(rp.strResA, pPr.resParaA()))
					continue;
				StrideRes strB=new StrideRes(line.charAt(229),Float.parseFloat(line.substring(232,239).trim()),Float.parseFloat(line.substring(241,248).trim()),Float.parseFloat(line.substring(250,255).trim()));
				if(!strB.similarTo(rp.strResB, pPr.resParaB()))
					continue;
				if(banPDB.contains(line.substring(0,4).toLowerCase()))
				{
//					System.out.println("Got "+line.substring(0,4).toLowerCase());
					continue;
				}
				
				double rmsd = rp.rmsd(line);
				
				double rmsdCutoff = pPr.cutoff(rp);
				
				if(rmsd>rmsdCutoff)
					continue;
				
				

				String resAName = line.substring(13,16);
				String resBName = line.substring(26,29);
				
				int rotA = rots.dunbrackCodeToInt(resAName, dunbrackCode(line.substring(16,20)));
				int rotB = rots.dunbrackCodeToInt(resBName, dunbrackCode(line.substring(29,33)));
				if(rotA < 0 || rotB < 0)
					continue;

				foundPairNum++;
				pMatrix[rotA][rotB]+=1.0;
			}
			

			in.close();
		}
		ProbabilityMatrixRT pm = new ProbabilityMatrixRT(pMatrix,foundPairNum);
		if(rp.strResB.resID-rp.strResA.resID > 3)
		{
			ProbabilityMatrixRT mirrorPM = FindSimilarPairsRT.findPMofRotPair(rp.mirror(), pPr, banPDB,rots);
			mirrorPM.transpose();
			pm=pm.merge(mirrorPM);
		}
		return pm;
	}
	
	public static ArrayList<String> findPMofRotPairPrintList(RotPair rp, PairPara pPr,HashSet<String> banPDB, Rotamers rots) throws IOException
	{
		double[][] pMatrix=new double[rots.rotamerNum()][rots.rotamerNum()];
		ArrayList<String> files = getFileList(rp, pPr);
		
		ArrayList<String> list = new ArrayList<String>();
		int foundPairNum=0;
		for(String s : files)
		{
			BufferedReader in = new BufferedReader(new FileReader(s));
			String line;
			while((line=in.readLine())!=null)
			{
				StrideRes strA=new StrideRes(line.charAt(202),Float.parseFloat(line.substring(205,212).trim()),Float.parseFloat(line.substring(214,221).trim()),Float.parseFloat(line.substring(223,228).trim()));
				if(!strA.similarTo(rp.strResA, pPr.resParaA()))
					continue;
				StrideRes strB=new StrideRes(line.charAt(229),Float.parseFloat(line.substring(232,239).trim()),Float.parseFloat(line.substring(241,248).trim()),Float.parseFloat(line.substring(250,255).trim()));
				if(!strB.similarTo(rp.strResB, pPr.resParaB()))
					continue;
				if(banPDB.contains(line.substring(0,4).toLowerCase()))
				{
//					System.out.println("Got "+line.substring(0,4).toLowerCase());
					continue;
				}
				
				double rmsd = rp.rmsd(line);
				
				double rmsdCutoff = pPr.cutoff(rp);
				
				if(rmsd>rmsdCutoff)
					continue;
				
				

				String resAName = line.substring(13,16);
				String resBName = line.substring(26,29);
				
				int rotA = rots.dunbrackCodeToInt(resAName, dunbrackCode(line.substring(16,20)));
				int rotB = rots.dunbrackCodeToInt(resBName, dunbrackCode(line.substring(29,33)));
				if(rotA < 0 || rotB < 0)
					continue;
				list.add(line);
				foundPairNum++;
				pMatrix[rotA][rotB]+=1.0;
			}
			

			in.close();
		}
		ProbabilityMatrixRT pm = new ProbabilityMatrixRT(pMatrix,foundPairNum);
		if(rp.strResB.resID-rp.strResA.resID > 3)
		{
			ArrayList<String> list2 = FindSimilarPairsRT.findPMofRotPairPrintList(rp.mirror(), pPr, banPDB, rots);
			for(String s : list2)
				list.add(s+"@");
			
			
		}
		return list;
	}
	
	public static void main(String[] args) throws IOException
	{
		
		PDB pdb=new PDB("E:\\pairwiseDesign\\testPDB\\1fhlMut\\pdb1fhl.ent","1fhl");
		ProteinChain chain=pdb.getChain('A');
		Residue resA=chain.getResidue(93);
		Residue resB=chain.getResidue(143);
		ResPair rp1=new ResPair(resA,resB,"1fhl",'A');
		StrideProtein sp=new StrideProtein("E:\\pairwiseDesign\\testPDB\\1fhlMut\\1fhl.meastr");
		rp1.addStrInfo(sp);
		ArrayList<String> files = getFileList(rp1,new PairPara(0,0.7,1,3,1));

		HashSet<String> ban = new HashSet<String>();
		ban.add("1fob");
		
	}
}
