package similarSearch;
import java.io.*;
import model.*;
import java.util.*;

public class PairsOfPDB 
{
	private ArrayList<ResPair> pairs=new ArrayList<ResPair>();
	
	public PairsOfPDB(PDB pdb,StrideProtein sp,double cutoff)
	{
		for(ProteinChain chain : pdb.getChains())
		{
			pairs=chain.findContactPairs(cutoff);
			for(ResPair resPair : pairs)
			{
				resPair.addStrInfo(sp);
			}
		}
	}
	
	public PairsOfPDB(String pdbFile,String strideFile,double cutoff) throws IOException
	{
		this(new PDB(pdbFile),new StrideProtein(strideFile),cutoff);
	}
	
	public PairsOfPDB(String pdbFile,String pdbID,String strideFile,double cutoff) throws IOException
	{
		this(new PDB(pdbFile,pdbID),new StrideProtein(strideFile),cutoff);
	}
	
	public void printPairs(PrintStream out)
	{
		for(ResPair resPair : this.pairs)
		{
			out.println(resPair.toString());
		}
	}
	
	public ArrayList<ResPair> getPairs()
	{
		return this.pairs;
	}
	
	public static void main(String[] args) throws IOException
	{
		PairsOfPDB pairsOfpdb=new PairsOfPDB("E:\\pdb\\2pii\\mod_2.pdb","mod2","E:\\pdb\\2pii\\mod2_mea.str",8.0);
		pairsOfpdb.printPairs(System.out);
		
	}
	
}
