package similarSearch;
import model.StrideRes;

public final class ResPara 
{
	private int ssLevel;
	private int sasaLevel;
	private int ppLevel;
	private int sampleNumCutoff=300;
	private int ppSur = 0;
	private boolean difSurPP = false;
	
	
	public ResPara()
	{
		this(1, 5, 4);
	}
	
	public ResPara(int ss, int sasa, int pp)
	{
		this.ssLevel = ss;
		this.sasaLevel = sasa;
		this.ppLevel = pp;
	}
	
	public ResPara(int ss,int sasa, int pp, int ppSur)
	{
		this.ssLevel = ss;
		this.sasaLevel = sasa;
		this.ppLevel = pp;
		this.difSurPP = true;
		this.ppSur = ppSur;
	}
	
	public static ResPara defaultResPara()
	{
		return new ResPara(1,5,4);
	}
	
	public void setSampleNumCutoff(int n)
	{
		this.sampleNumCutoff = n;
	}
	
	public int getSampleNumCutoff()
	{
		return this.sampleNumCutoff;
	}
	
	public int ssLevel()
	{
		return this.ssLevel;
	}
	
	public int sasaLevel()
	{
		return this.sasaLevel;
	}
	
	public int ppLevel()
	{
		return this.ppLevel;
	}
	
	public boolean surDif()
	{
		return this.difSurPP;
	}
	
	public int ppLevel(float area)
	{
		float areaNor = ResCharacter.sasaAreaNormalize(area);
		if(areaNor > 0.66)
			return this.ppSur;
		else 
			return this.ppLevel;
	}
	
	public ResPara demote()
	{
		if(this.ppLevel > 4)
			return new ResPara(this.ssLevel,this.sasaLevel,this.ppLevel-1);
		else if(this.sasaLevel >3)
			return new ResPara(this.ssLevel,this.sasaLevel-1,this.ppLevel);
		else if(this.ppLevel > 2)
			return new ResPara(this.ssLevel,this.sasaLevel,this.ppLevel-1);
		else if(this.sasaLevel > 1)
			return new ResPara(this.ssLevel,this.sasaLevel-1,this.ppLevel);
		else 
			return new ResPara(1,0,0);
	}
	
	public String toString()
	{
		return this.ssLevel+"_"+this.sasaLevel+"_"+this.ppLevel;
	}
}
