package thermo;
import java.io.*;
import java.util.*;
import model.*;

public class ChangeNativePDBID {

	public static int startID(ArrayList<String> lines)
	{
		for(String s : lines)
		{
			if(s.startsWith("ATOM"))
				return Integer.parseInt(s.substring(22,26).trim());
				
		}
		return 0;
	}
	
	public static boolean hasGap(ArrayList<String> lines)
	{
		int len = lines.size();
		int lastID = Integer.parseInt(lines.get(0).substring(22,26).trim());
		boolean flag = false;
		for(int i=1;i<len;i++)
		{
			if(!lines.get(i).startsWith("ATOM")) continue;
			int thisID = Integer.parseInt(lines.get(i).substring(22,26).trim());
			if(thisID == lastID || thisID-lastID == 1)
			{
				lastID = thisID;
				continue;
			}
			System.out.println(lines.get(i));
			flag = true;
			return flag;
		}
		return flag;
	}
	
	public static boolean checkAA(ArrayList<String> lines)
	{
		int len = lines.size();
		boolean flag = false;
		for(int i=0;i<len;i++)
		{
			if(!lines.get(i).startsWith("ATOM") && !lines.get(i).startsWith("HETATM")) continue;
			if(ResName.isResName(lines.get(i).substring(17,20))) continue;
			System.out.println(lines.get(i));
			flag = true;
		}
		return flag;
	}
	
	public static void checkAllNNAA() throws IOException
	{
		ArrayList<String> chainList = usr.FileToList.getList("/nfs/amino-home/pengx/mutationThermo/chainList");
		for(String ch : chainList)
		{
			String pdbID = ch.substring(0,4);
			char chainID = ch.charAt(4);
			ArrayList<String> lines = usr.FileToList.getList("/nfs/amino-home/pengx/mutationThermo/originalPDB/" + pdbID + ".pdb");
			ArrayList<String> chLines = new ArrayList<String>();
			PDB pdb = new PDB("/nfs/amino-home/pengx/mutationThermo/originalPDB/" + pdbID + ".pdb");
			ProteinChain pc;
			if(pdb.getChains().size() == 1)
			{
				pc = pdb.getFirstChain();
				for(String s : lines)
				{
					if(!s.startsWith("ATOM") && !s.startsWith("HETATM")) continue;
					String name = s.substring(17,20).trim();
					if(name.equals("O") || name.equals("S") || name.equals("CA")) continue;
					if(name.equals("HOH") || name.equals("AP5") || name.equals("IMD")) continue;
					if(name.equals("A") || name.equals("T") || name.equals("G") || name.equals("C")) continue;
					if(name.equals("CEM") || name.equals("DOD") || name.equals("MPD")) continue;
					if(name.equals("PMP") || name.equals("TEM") || name.equals("SO4") || name.equals("BLA")) continue;
					if(name.equals("PO4") || name.equals("BCT") || name.equals("FK5") || name.equals("OLA")) continue;
					if(name.equals("MN") || name.equals("FE") || name.equals("ZN") || name.equals("GOL")) continue;
					if(name.equals("NH2") || name.equals("SUL") || name.equals("EQU") || name.equals("PMS")) continue;
					if(name.equals("RIP") || name.equals("BME") || name.equals("ACE") || name.equals("TAC")) continue;
					if(name.equals("NAG") || name.equals("MAN") || name.equals("GLC") || name.equals("ATP")) continue;
					if(name.equals("MP3") || name.equals("GOL") || name.equals("CL")) continue;
					if(name.equals("AMP") || name.equals("ANP") || name.equals("CD") || name.equals("NA")) continue;
					if(name.equals("MG") || name.equals("CU") || name.equals("K") || name.equals("UNK")) continue;
					
					
					
					
					chLines.add(s);
				}
			}
			else
			{
				for(String s : lines)
				{
					
					if(!s.startsWith("ATOM") && !s.startsWith("HETATM")) continue;
					if(s.charAt(21) != chainID) continue;
					String name = s.substring(17,20).trim();
					if(name.equals("O") || name.equals("S") || name.equals("CA")) continue;
					if(name.equals("HOH") || name.equals("AP5") || name.equals("IMD")) continue;
					if(name.equals("A") || name.equals("T") || name.equals("G") || name.equals("C")) continue;
					if(name.equals("CEM") || name.equals("DOD") || name.equals("MPD")) continue;
					if(name.equals("PMP") || name.equals("TEM") || name.equals("SO4") || name.equals("BLA")) continue;
					if(name.equals("PO4") || name.equals("BCT") || name.equals("FK5") || name.equals("OLA")) continue;
					if(name.equals("MN") || name.equals("FE") || name.equals("ZN") || name.equals("GOL")) continue;
					if(name.equals("NH2") || name.equals("SUL") || name.equals("EQU") || name.equals("PMS")) continue;
					if(name.equals("RIP") || name.equals("BME") || name.equals("ACE") || name.equals("TAC")) continue;
					if(name.equals("NAG") || name.equals("MAN") || name.equals("GLC") || name.equals("ATP")) continue;
					if(name.equals("MP3") || name.equals("GOL") || name.equals("CL")) continue;
					if(name.equals("AMP") || name.equals("ANP") || name.equals("CD") || name.equals("NA")) continue;
					if(name.equals("MG") || name.equals("CU") || name.equals("K") || name.equals("UNK")) continue;
					chLines.add(s);
				}
			}
			
			//System.out.println(pdbID + " " + chLines.size());
			if(checkAA(chLines))
				System.out.println(ch);
			
		}
	}
	
	public static void changeID(String pdbID) throws IOException
	{
		String oldFile = "/nfs/amino-home/pengx/mutationThermo/nativePDBs/" + pdbID + "/" + pdbID + ".pdb";
		String newFile = "/nfs/amino-home/pengx/mutationThermo/natPDBchID/" + pdbID + ".pdb";
		ArrayList<String> lines = usr.FileToList.getList(oldFile);
		int startID = startID(lines);
		boolean hasGap = hasGap(lines);
		boolean hasUnknownAA = checkAA(lines);
		if(hasGap)
		{
			System.out.println(pdbID + " has gap");
		//	throw new RuntimeException();
		}
		if(hasUnknownAA)
		{
			System.out.println(pdbID + " has unknown aa" );
		//	throw new RuntimeException();
		}
		PrintStream out = new PrintStream(newFile);
		int lastOldID = -100;
		int lastNewID = 0;
		for(String s : lines)
		{
			if(!s.startsWith("ATOM"))
			{
				out.println(s);
				continue;
			}
			
			int thisOldID = Integer.parseInt(s.substring(22,26).trim());
			int thisNewID = -1;
			if(thisOldID == lastOldID)
				thisNewID = lastNewID;
			else
			{
				lastOldID = thisOldID;
				thisNewID = lastNewID + 1;
				lastNewID = thisNewID;
			}
			
			out.printf(s.substring(0,22)+"%4d"+s.substring(26,s.length())+"\n", thisNewID);
			
		}
		out.close();
	}
	
	public static void changeAll() throws IOException
	{
		ArrayList<String> lines = usr.FileToList.getList( "/nfs/amino-home/pengx/mutationThermo/wtScwList");
		for(String s : lines)
		{
			String pdbID = s.substring(0,5);
			changeID(pdbID);
		}
	}
	
	public static void main(String[] args) throws IOException
	{
		changeAll();
	}
}
