package thermo;

import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;

public class Correlation {
	public static void getCorrelationS1S2(String subList, String result) throws IOException
	{
		ArrayList<String> lines = usr.FileToList.getList(result);
		ArrayList<Double> s2s = new ArrayList<Double>();
		ArrayList<Double> exps = new ArrayList<Double>();
		ArrayList<Double> s1s = new ArrayList<Double>();
		
		ArrayList<String> subLines = usr.FileToList.getList(subList);
		HashSet<String> set = new HashSet<String>();
		for(String s : subLines)
			set.add(s);
		
		for(String s : lines)
		{
			if(!set.contains(s.substring(0,5))) continue;
			String[] spt = s.split(" +");
			s2s.add(Double.parseDouble(spt[5]));
			s1s.add(Double.parseDouble(spt[4]));
			exps.add(Double.parseDouble(spt[6]));
		}
		ArrayList<Double> s1s2 = new ArrayList<Double>();
		for(int i=0;i<s1s.size();i++)
			s1s2.add(s1s.get(i) + s2s.get(i));
		double coS1 = math.CorrelationCoefficient.correlation(s1s, exps);
		double coS2 = math.CorrelationCoefficient.correlation(s2s, exps);
		double coS12 = math.CorrelationCoefficient.correlation(s1s2, exps);
		
		System.out.printf("%6.4f %6.4f %6.4f\n",coS1,coS2,coS12);
		
	}
	
	public static void getCorrelationVdw(String subList, String result) throws IOException
	{
		ArrayList<String> lines = usr.FileToList.getList(result);
		ArrayList<Double> vNw = new ArrayList<Double>();
		ArrayList<Double> exps = new ArrayList<Double>();
		ArrayList<Double> vW = new ArrayList<Double>();
		
		ArrayList<String> subLines = usr.FileToList.getList(subList);
		HashSet<String> set = new HashSet<String>();
		for(String s : subLines)
			set.add(s);
		
		for(String s : lines)
		{
			if(!set.contains(s.substring(0,5))) continue;
			String[] spt = s.split(" +");
			vNw.add(Double.parseDouble(spt[5]));
			vW.add(Double.parseDouble(spt[4]));
			exps.add(Double.parseDouble(spt[6]));
		}
		
		double coNw = math.CorrelationCoefficient.correlation(vNw, exps);
		double coW = math.CorrelationCoefficient.correlation(vW, exps);
		
		System.out.printf("%6.4f %6.4f\n",coNw,coW);
		
	}
	

	public static void main(String[] args) throws IOException
	{
		if(args[0].equals("s1s2"))
			getCorrelationS1S2(args[1],args[2]);
		else if(args[0].equals("vdw"))
			getCorrelationVdw(args[1],args[2]);
	}
}
