#!/usr/bin/env python
import sys,re

class Snp:
	
	len_limit = 20
	aa = '[ARNDCEQGHILKMFPSTWYV]'

	def __init__(self, query='', pos='', aa1='', aa2=''):
		self.query = query
		self.pos = pos
		self.aa1 = aa1
		self.aa2 = aa2


	def test_init(self):
		if len(self.query) < Snp.len_limit:
			print 'Illegal query: '+self.query
			sys.exit()

		if re.match('^\d+$',self.pos):
			self.pos = int(re.match('^(\d+)$',self.pos).group(1))
			if self.pos < 1 or self.pos > len(self.query):
				print 'Illegal position specified: '+str(self.pos)
				sys.exit()
		else:
			print 'Illegal position specified: '+self.pos
			sys.exit()
			
		if self.query[self.pos-1] != self.aa1:
			print 'Illegal aa1 residue: '+self.aa1
			sys.exit()

		if not re.search(Snp.aa,self.aa2) or self.aa2 == self.aa1:
			print 'Illegal aa2 residue: '+self.aa2
			sys.exit()


	def print_test(self):
		print self.query
		print self.pos
		print self.aa1
		print self.aa2
